''******************************************
''*         My AWD1v2.spin                 *
''* This is my Lynxmotion AWD1v2 4wd robot *
''* with a Sabretooth motor controller and *
''* a whole bunch of stuff that I will be  *
''* adding in the coming months as long as *
''* I don't blow anything up in the process*
''* Started: 08-10-2010                    *
''******************************************
''
''PINOUTS:
''P0 - Left Motor P1 - Right Motor
''P2 - BattleSwitch relay to power motor controller, shut off when doing other things
''P6 - TX to Blackfin           P7 - RX from Blackfin
''P14 - Servo Head Tilt         P15 - Servo Head Pan

CON

  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

  ServoCh1 = 0                                          ' Forward or Reverse(1500-Stop,Below 1500-Reverse, Above 1500-Forward)
  ServoCh2 = 1                                          ' Turn Left or Right (1500-Straight, Below 1500 turns Right, Above 1500 turns Left)  
  ServoCh3 = 2                                          ' BattleSwitch(1500-turn off, 2000-turn on)
  MS_001 = 80_000_000 / 1_000                           ' To calculate when using the pause method in MS If you want to wait 0.1 seconds, 
                                                        ' you use pause(100). Want to wait 2.5 seconds, use pause(2_500).
  RX_Pin = 6
  TX_Pin = 7                                                      

VAR

                                       
byte    BFinData[64]                                 ' This is for the data that the blackfin sends back to us, when the blackfin first boots it sends 61 chars then a cr/lf
byte    BFinMean[20]                                 ' responce to vm is 19 characters long followed by a cr/lf
byte    Y_Mean[4]                                    ' store 3 numbers + 0 to terminate the string
byte    U_Mean[4]                                    ' store 3 numbers + 0 to terminate the string
byte    V_Mean[4]                                    ' store 3 numbers + 0 to terminate the string
long    MeanResult
long    Y_Result
long    U_Result
long    V_Result
''long    value

OBJ

''  LCD  : "debug_lcd"
''  ping : "ping"
  SERIAL : "Extended_FDSerial"
  SERVO : "Servo32v7"  
  PST : "Parallax Serial Terminal"
  
    
    
PUB Blackfin
    PST.Start(115_200)         'starts up debug tool for PST
    PAUSE (1_000)
    SERIAL.START(RX_Pin, TX_Pin, 0, 115200)
    Pause (1_000)
    SERIAL.SetDelimiter(10)     'the blackfin mostly sends back responces with a cr then lf
    PST.Str(String("Resetting Blackfin Camera...",13))
    Pause (10)
    SERIAL.RxFlush
    Pause (20)
    SERIAL.Str (String("$!")) ' This sends the reset command to the blackfin
    pause (10_000) ' pause for 10 seconds to allow the blackfin to reset and become ready
    
    SERIAL.RxFlush
    PST.Str (String("Sending V Command...",13))
    SERIAL.Str (String("V"))
''    SERIAL.RxStrTime(300,@BFinData)
    SERIAL.RxStr (@BFinData)
    PST.Str(@BFinData)
    Pause (10)
   repeat
    SERIAL.RxFlush
    SERIAL.SetDelimiter(10)
    PST.Str (String("Sending vm command...",13))
    SERIAL.Str (String("vm"))   'get mean values for Y,U,V
''    SERIAL.RxStrTime(300,@BFinMean)
    SERIAL.RxStr(@BFinMean)
    PST.Str(@BFinMean)                                     ' outputs ascii looks just this ##vmean 111 222 333

    Y_Mean[0] := BFinMean[8]
    Y_Mean[1] := BFinMean[9]
    Y_Mean[2] := BFinMean[10]

    U_Mean[0] := BFinMean[12]
    U_Mean[1] := BFinMean[13]
    U_Mean[2] := BFinMean[14]

    V_Mean[0] := BFinMean[16]
    V_Mean[1] := BFinMean[17]
    V_Mean[2] := BFinMean[18]

    PST.Str (String("Hex output looks like this:",13))
    PST.Dec (Y_Mean[0])                                    'this shows the output in hex
    PST.Str (String("-"))                                        
    PST.Dec (Y_Mean[1])
    PST.Str (String("-"))
    PST.Dec (Y_Mean[2])
    PST.Str (String("-"))
    PST.Dec (U_Mean[0])
    PST.Str (String("-"))
    PST.Dec (U_Mean[1])
    PST.Str (String("-"))
    PST.Dec (U_Mean[2])
    PST.Str (String("-"))
    PST.Dec (V_Mean[0])
    PST.Str (String("-"))
    PST.Dec (V_Mean[1])
    PST.Str (String("-"))
    PST.Dec (V_Mean[2])
    PST.Str (String(13))
''    PST.Str (String(13))

''    MeanResult[0] := Y_Mean[0]  
''    MeanResult[1] := Y_Mean[1]
''    MeanResult[2] := Y_Mean[2]  
''    MeanResult[3] := Y_Mean[0] + Y_Mean[1] + Y_Mean[2]
''    PST.dec (MeanResult[3]) 
''    PST.Str (String(13))
    PST.Str (String(13))

     Y_Result := str2dec(@BFinMean[ 8 ] )
     U_Result := str2dec(@BFinMean[ 12 ])
     V_Result := str2dec(@BFinMean[ 16 ])
    PST.Str (String("Y_Result = "))
    PST.Dec (Y_Result)
    PST.Str (String(13))
    PST.Str (String("U_Result = "))
    PST.DEC (U_Result)
    PST.Str (String(13))
    PST.Str (String("V_Result = "))
    PST.DEC (V_Result)
    PST.Str (String(13))
        
''   SERIAL.RxFlush  
    Pause (1000)

    
PUB Start
    SERVO.start
    SERVO.ramp
    SERVO.Set(ServoCh3,2000)
    Pause (100)
    SERVO.Set(ServoCh1,1500)   ''Center
    Pause (100)
    SERVO.Set(ServoCh2,1500)   ''Center
    Pause (2_000)              ''After BattleSwitch is turned on, allow a few seconds to settle
    
    

DemoIT

PUB DemoIT
    SERVO.Set(ServoCh1,1800)   ''Go Forward
    Pause (2_000)              ''Pause for a sec
    SERVO.Set(ServoCh1,1500)   ''Stop
    Pause (2_000)              ''Pause for a sec
    SERVO.Set(ServoCh1,1100)   ''Go Backwards
    Pause (2_000)              ''Pause for a sec
    SERVO.Set(ServoCh1,1500)   ''Stop
    Pause (2_000)              ''Pause for a sec  
    SERVO.Set(ServoCh2,2000)   ''Turn Left
    Pause (2_000)              ''Pause for a sec
    SERVO.Set(ServoCh2,1500)   ''Stop
    Pause (2_000)              ''Pause for a sec
    SERVO.Set(ServoCh2,900)   ''Turn Right
    Pause (2_000)              ''Pause for a sec
    SERVO.Set(ServoCh2,1500)   ''Stop





PUB LoopIT
    repeat
    

PUB pause(ms) | t

  t := cnt
  repeat ms
    waitcnt(t += MS_001)


pub str2dec(pntr) | val, c

  val := 0                                                      ' clear workspace

  repeat
    c := byte[pntr++]                                           ' get character, point to next
    if (c => "0") and (c =< "9")                                ' digit?
      val := (val * 10) + (c - "0")                             ' yes, add to value
    else
      quit                                                      ' no, we're done

  return val

